<?php defined('SYSPATH') OR die('No direct access allowed.');

header('Content-Type: text/xml; charset=UTF-8');
echo '<?xml version="1.0" encoding="UTF-8" ?>'; echo "\n"; ?>
<!DOCTYPE GraphXML SYSTEM "<?php echo $dtd; ?>">
<GraphXML xmlns:xlink="http://www.w3.org/1999/xlink">
<graph>

<style>
	<line tag="node" class="main" colour="#ffffff"/>
	<line tag="node" class="child_node" colour="blue"/>
	<line tag="node" class="nagios_node" colour="red"/>
	<line tag="node" class="relation_node" colour="green"/>
	<line tag="node" class="hs0" colour="#219421"/>
	<line tag="node" class="hs1" colour="#F83838"/>
	<line tag="node" class="hs2" colour="#F83838"/>
	<line tag="edge" class="secondary_edge" colour="blue" linestyle="dashed"/>
</style>
<node class="nagios_node" name="0">
	<label><?php echo sprintf(_('%s Process'), Kohana::config('config.product_name')) ?></label>
</node>
<?php
foreach ($hosts as $node) {
	$title_str = sprintf(_('Host: %s Status: %s (Click for detail)'), $node['name'], Current_status_Model::status_text($node['state'], $node['has_been_checked']));
	echo sprintf("<node class=\"hs%u\" name=\"%s\"><label>%s</label><dataref><ref xlink:show=\"replace\" xlink:href=\"extinfo/details?host=%s\" xlink:title=\"%s\"/></dataref></node>\n",
		       $node['state'], $node['name'], $node['name'], urlencode($node['name']), $title_str);
}

foreach ($host_parents as $host => $parents) {
	foreach ($parents as $parent) {
		echo '<edge source="'.$parent.'" target="'.$host.'"/>';
	}
}

foreach ($no_parents as $host) {
	echo '<edge source="0" target="'.$host.'"/>';
}
?>
</graph>
</GraphXML>
